// ©barsunduk© 11/2011
import javax.microedition.lcdui.Graphics;
import javax.microedition.lcdui.Image;

// класс копирующий битовую карту картинки
// содержит методы обработки пикселей
public class Lib_bitmap {

    private static int pwid = 0;
    private static int phei = 0;
    private static int[] pixels = null;
    private static int bcol = 0;

    public static int _mix = 0;
    public static int _solid = 1;

    public static void setback(int col) {
        bcol = col;
    }

    public static int getback() {
        return bcol;
    }

    public static int getcol() {
        return M.G.getColor();
    }

    public static void setcol(int col) {
        M.G.setColor(col);
    }

    public static String i2h(int i) {
        return Integer.toHexString(i);
    }

    public static int h2i(String s) {
        while (s.length() < 8) {
            s = "0" + s;
        }
        String hi = s.substring(0, 4);
        String lo = s.substring(4, s.length());
        return Integer.parseInt(lo, 16) | (Integer.parseInt(hi, 16) << 16);
    }

    // ширина битмапа
    public static int width() {
        return pwid;
    }

    // высота битмапа
    public static int height() {
        return phei;
    }

    public static int getalpha(int col) {
        return (col >> 24) & 0xff;
    }

    public static int getred(int col) {
        return (col >> 16) & 0xff;
    }

    public static int getgreen(int col) {
        return (col >> 8) & 0xff;
    }

    public static int getblue(int col) {
        return col & 0xff;
    }

    public static int argb2int(int alpha, int red, int green, int blue) {
        alpha = (alpha < 0) ? 0 : (alpha & 0xff);
        red = (red < 0) ? 0 : (red & 0xff);
        green = (green < 0) ? 0 : (green & 0xff);
        blue = (blue < 0) ? 0 : (blue & 0xff);
        return (alpha << 24) | (red << 16) | (green << 8) | blue;
    }

    public static int pixmix(int forecolor, int backcolor) {
        int a1 = (forecolor >> 24) & 0xff;
        int a2 = (backcolor >> 24) & 0xff;
        int r1 = (forecolor >> 16) & 0xff;
        int r2 = (backcolor >> 16) & 0xff;
        int g1 = (forecolor >> 8) & 0xff;
        int g2 = (backcolor >> 8) & 0xff;
        int b1 = forecolor & 0xff;
        int b2 = backcolor & 0xff;
        int a3 = 255 - a1;
        r1 = ((r1 * a1 + r2 * a3) >> 8);
        g1 = ((g1 * a1 + g2 * a3) >> 8);
        b1 = ((b1 * a1 + b2 * a3) >> 8);
        return ((a1 | a2) << 24) | (r1 << 16) | (g1 << 8) | b1;
    }

    // попадает ли точка в пределы битмапа
    public static int inrect(int x, int y) {
        return ((x >= 0) & (y >= 0) & (x < pwid) & (y < phei)) ? 1 : 0;
    }

    // получить цвет пиксела битмапа
    // если точка вне пределов, то возвращается цвет фона
    public static int point(int x, int y) {
        return (inrect(x, y)==1) ? pixels[y * pwid + x] : bcol;
    }

    // установить цвет пиксела
    public static void setpixel(int x, int y, int c) {
        if (inrect(x, y)==1) {
            pixels[x + y * pwid] = c;
        }
    }

    // получить цвет пиксела картинки
    public static int getpixel(Image img, int x, int y) {
        int res = 0;
        int[] pix = new int[1];
        int w = img.getWidth();
        int h = img.getHeight();
        if ((x >= 0)&&(y >= 0)&&(x < w)&&(y < h)) {
            img.getRGB(pix, 0, w, x, y, 1, 1);
            res = pix[1];
        }
        return res;
    }

    // установить цвет пиксела, если прозрачности цвета > 0
    public static void plotpixel(int x, int y, int c) {
        if (inrect(x, y)==1) {
            if(((c >> 24) & 0xff) > 0) {
                pixels[x + y * pwid] = c;
            }
        }
    }

    // нарисовать точку (можно полупрозрачную)
    public static void plot(int x, int y, int c) {
        int f = x + y * pwid;
        if (inrect(x, y)==1) {
            pixels[f] = pixmix(c, pixels[f]);
        }
    }

    // убить битмап
    public static void free() {
        pixels = null;
        pwid = 0;
        phei = 0;
    }

    // создать пустой битмап
   public static void createwh(int w, int h) {
        pixels = null;
        pwid = 0;
        phei = 0;
        if ((w > 0)&&(h > 0))
        {
            pixels = new int[w * h];
            pwid = w;
            phei = h;
        }
    }

    // создать битмап из картинки
    public static void createimg(Image img) {
        createwh(img.getWidth(), img.getHeight());
        if ((pwid | phei) != 0) {
            img.getRGB(pixels, 0, pwid, 0, 0, pwid, phei);
        }
    }

    // создать битмап из части картинки
    public static void createimgwh(Image img, int x, int y, int w, int h) {
        createwh(w, h);
        if ((pwid | phei) != 0) {
            img.getRGB(pixels, 0, pwid, x, y, w, h);
        }
    }

    // создать битмап из массива пикселей
    private static void create(int[] rgb, int w) {
        pixels = null;
        pwid = w;
        phei = rgb.length / pwid;
        int l = pwid * phei;
        pixels = new int[l];
        for(int i = 0; i < l; i++) {
            pixels[i] = rgb[i];
        }
    }

    // создать картинку из битмапа
    public static Image getimage() {
        return Image.createRGBImage(pixels, pwid, phei, true);
    }

    // нарисовать битмап на экране MP
    public static void imgdraw(int x, int y) {
        M.G.drawRGB(pixels, 0, pwid, x, y, pwid, phei, true);
    }
    // заполнить битмап одним цветом
    public static void flood(int col) {
        int l = pwid * phei;
        for (int i = 0; i < l; i++)
            pixels[i] = col;
    }

    // заменить цвет на новый
    public static void newcolor(int col, int newcol) {
        int l = pwid * phei;
        for (int i = 0; i < l; i++)
            if (pixels[i] == col)
                pixels[i] = newcol;
    }

    // заменить все цвета на новый
    // альфа канал не учитывается и не изменяется
    public static void floodrgb(int newrgb) {
        int l = pwid * phei;
        newrgb &= 0x00ffffff;
        for (int i = 0; i < l; i++) {
            pixels[i] = (pixels[i] & 0xff000000) | newrgb;
        }
    }

    // заменить цвет rgb на новый
    // альфа канал не учитывается и не изменяется
    public static void newrgb(int rgb, int newrgb) {
        int l = pwid * phei;
        newrgb &= 0x00ffffff;
        rgb &= 0x00ffffff;
        for (int i = 0; i < l; i++) {
            if ((pixels[i] & 0x00ffffff) == rgb) {
                pixels[i] = (pixels[i] & 0xff000000) | newrgb;
            }
        }
    }

    // заменить цвет rgb на новый argb
    // альфа канал не учитывается при поиске цвета rgb, но заменяется
    public static void newargb(int rgb, int newargb) {
        int l = pwid * phei;
        rgb &= 0x00ffffff;
        for (int i = 0; i < l; i++) {
            if ((pixels[i] & 0x00ffffff) == rgb) {
                pixels[i] = newargb;
            }
        }
    }

    // заменить альфа канал на новый
    // (цвет rgb не учитывается)
    public static void newalpha(int alpha, int newalpha) {
        int l = pwid * phei;
        alpha <<= 24;
        newalpha <<= 24;
        for (int i = 0; i < l; i++)
            if ((pixels[i] & 0xff000000) == alpha)
                pixels[i] = (pixels[i] & 0x00ffffff) | newalpha;
    }

    // обнулить альфа канал, если его значение мешьше alpha
    public static void cutalpha(int alpha) {
        int l = pwid * phei;
        alpha <<= 24;
        for (int i = 0; i < l; i++) {
            if (((pixels[i] >> 24) & 0xff) < alpha) {
                pixels[i] = pixels[i] & 0x00ffffff;
            }
        }
    }

    // изменить значение альфа канала
    // альфа = [0..255]
    // учитывая прежнее значение
    public static void alphablend(int n) {
        int l = pwid * phei;
        n += 1;
        for (int i = 0; i < l; i++) {
            int a = ((pixels[i] >> 24) & 0xff);
            a = ((n * a) >> 8) & 0xff;
            pixels[i] = (pixels[i] & 0x00ffffff) | (a << 24);
        }
    }

    // заменить цвета на оттенки серого
    // с учетом оптических особенностей восприятия
    public static void gray() {
        int l = pwid * phei;
        for (int i = 0; i < l; i++) {
            int a = pixels[i] & 0xff000000;
            int r = (pixels[i] >> 16) & 0xff;
            int g = (pixels[i] >> 8) & 0xff;
            int b = pixels[i] & 0xff;
//            b = (int) ((0.3 * r + 0.59 * g + 0.11 * b) / 3);
            b = (77 * r + 151 * g + 28 * b) >> 8;
            pixels[i] = a | b | (b << 8) | (b << 16);
        }
    }

    // окружить силуэт линией
    // если прозрачность одного из пикселов сверху/снизу/слева/справа
    // больше альфа-порога 0,
    // то текущий пиксел перекрашивается в цвет бордюра linecolor
    public static void outline(int linecolor) {
        int l = pwid * phei;
        int[] bmp = new int[l];
        for (int y = 0; y < phei; y++)
        for (int x = 0; x < pwid; x++) {
            int count = 0;
            if (((point(x - 1, y) >> 24) & 0xff) > 0) {
                count++;
            }
            if (((point(x + 1, y) >> 24) & 0xff) > 0) {
                count++;
            }
            if (((point(x, y - 1) >> 24) & 0xff) > 0) {
                count++;
            }
            if (((point(x, y + 1) >> 24) & 0xff) > 0) {
                count++;
            }
            if (count > 0) {
                bmp[y * pwid + x] = linecolor;
            }
        }
        for (int i = 0; i < l; i++) {
            if (((pixels[i] >> 24) & 0xff) < 1) {
                pixels[i] = bmp[i];
            }
        }
        bmp = null;
    }

    // заливка всех пикселов с альфа-каналом > alphamin
    // цвет может быть полупрозрачным - заливка идет смешением каналов
    public static void flooda(int overcolor, int alphamin) {
        int c = 0;
        int l = pwid * phei;
        for (int i = 0; i < l; i++) {
            if (((pixels[i] >> 24) & 0xff) > alphamin) {
                pixels[i] = pixmix(overcolor, pixels[i]);
            }
        }
    }

    // размыть битмап
    public static void blur() {
        int c = 0;
        int l = pwid * phei;
        int[] bmp = null;
        bmp = new int[l];
        for (int i = 0; i < l; i++) {
            bmp[i] = pixels[i];
        }
        for (int y = 0; y < phei; y++)
        for (int x = 0; x < pwid; x++) {
            int r = 0;
            int g = 0;
            int b = 0;
            c = point(x, y);
            r += ((c >> 16) & 0xff);
            g += ((c >> 8) & 0xff);
            b += (c & 0xff);
            c = point(x + 1, y);
            r += ((c >> 16) & 0xff);
            g += ((c >> 8) & 0xff);
            b += (c & 0xff);
            c = point(x - 1, y);
            r += ((c >> 16) & 0xff);
            g += ((c >> 8) & 0xff);
            b += (c & 0xff);
            c = point(x, y + 1);
            r += ((c >> 16) & 0xff);
            g += ((c >> 8) & 0xff);
            b += (c & 0xff);
            c = point(x, y - 1);
            r += ((c >> 16) & 0xff);
            g += ((c >> 8) & 0xff);
            b += (c & 0xff);
            r = (r / 5);
            g = (g / 5);
            b = (b / 5);
            c = (c & 0xff000000) | (r << 16) | (g << 8) | b;
            bmp[y * pwid + x] = c;
        }
        for (int i = 0; i < l; i++) {
            pixels[i] = bmp[i];
        }
        bmp = null;
    }

    // значения косинусов * 65535
    private static final int[] cos_table_180 =
    {
        65536, 65470, 65470, 65404, 65339, 65273, 65142, 65011, 64880, 64684,
        64487, 64290, 64094, 63832, 63569, 63242, 62980, 62652, 62324, 61931,
        61538, 61145, 60751, 60293, 59834, 59375, 58851, 58392, 57802, 57278,
        56754, 56164, 55574, 54919, 54329, 53673, 53018, 52297, 51642, 50921,
        50200, 49414, 48693, 47906, 47120, 46333, 45481, 44630, 43843, 42991,
        42074, 41222, 40304, 39387, 38469, 37552, 36634, 35651, 34668, 33751,
        32768, 31719, 30736, 29687, 28704, 27656, 26607, 25559, 24510, 23461,
        22413, 21299, 20250, 19136, 18022, 16908, 15794, 14680, 13565, 12451,
        11337, 10223, 9109, 7929, 6815, 5701, 4521, 3407, 2228, 1114, 0,
        -1114, -2228, -3407, -4521, -5701, -6815, -7929, -9109, -10223,
        -11337, -12451, -13565, -14680, -15794, -16908, -18022, -19136, -20250, -21299,
        -22413, -23461, -24510, -25559, -26607, -27656, -28704, -29687, -30736, -31719,
        -32702, -33751, -34668, -35651, -36634, -37552, -38469, -39387, -40304, -41222,
        -42074, -42991, -43843, -44630, -45481, -46333, -47120, -47906, -48693, -49414,
        -50200, -50921, -51642, -52297, -53018, -53673, -54329, -54919, -55574, -56164,
        -56754, -57278, -57802, -58392, -58851, -59375, -59834, -60293, -60751, -61145,
        -61538, -61931, -62324, -62652, -62980, -63242, -63569, -63832, -64094, -64290,
        -64487, -64684, -64880, -65011, -65142, -65273, -65339, -65404, -65470, -65470,
        -65536
    };

    // вычисление косинуса, если кто не догадался ..)
    public static int cos(int a) {
        int c = 0;
        a %= 360;
        a = (a < 0) ? 360 + a : a;
        if (a > 180) {
            c = -cos_table_180[a - 180];
        } else {
            c = cos_table_180[a];
        }
        return c;
    }

    // вычисление тангенса
    // ...шутю
    public static int sin(int a)
    {
        return cos(90 - a);
    }

    // хранение промежуточных результатов:
    // результат поворота
    private static int tx = 0;
    private static int ty = 0;
    // центр битмапа
    private static int cx = 0;
    private static int cy = 0;
    // синус, косинус
    private static int sa = 0;
    private static int ca = 0;

    // возвращает большее из 2 чисел
    public static int max(int a, int b) {
        return (a > b) ? a : b;
    }

    // возвращает меньшее из 2 чисел
    public static int min(int a, int b) {
        return (a < b) ? a : b;
    }

    // возвращает большее из 4 чисел
    public static int max4(int a, int b, int c, int d) {
        return max(a, b) > max(c, d) ? max(a, b) : max(c, d);
    }

    // возвращает меньшее из 4 чисел
    public static int min4(int a, int b, int c, int d) {
        return min(a, b) < min(c, d) ? min(a, b) : min(c, d);
    }

    // поворот точки на угол вокруг центра
    // [cx, cy] - центр
    private static void xyrotate(int x, int y) {
      int dx = x - cx;
      int dy = y - cy;
      tx = cx + ((dx * ca) >> 16) - ((dy * sa) >> 16);
      ty = cy + ((dx * sa) >> 16) + ((dy * ca) >> 16);
    }

    // поворот битмапа на любой угол
    public static void rotate(int angle) {
        sa = sin(angle);
        ca = cos(angle);
        int x = 0;
        int y = 0;
        int w = pwid;
        int h = phei;
        cx = x + (w >> 1);
        cy = y + (h >> 1);
        xyrotate(x, y);
        int x1 = tx;
        int y1 = ty;
        xyrotate(x + w - 1, y);
        int x2 = tx;
        int y2 = ty;
        xyrotate(x + w - 1, y + h - 1);
        int x3 = tx;
        int y3 = ty;
        xyrotate(x, y + h - 1);
        int x4 = tx;
        int y4 = ty;
        tx = min4(x1, x2, x3, x4);
        ty = min4(y1, y2, y3, y4);
        int neww = max4(x1, x2, x3, x4) - tx + 1;
        int newh = max4(y1, y2, y3, y4) - ty + 1;
        int l = neww * newh;
        int[] bmp = new int[l];
        int dx = (neww - w) >> 1;
        int dy = (newh - h) >> 1;
        for(x = 0; x < neww; x++)
        for(y = 0; y < newh; y++) {
            xyrotate(x - dx, y - dy);
            int i = x + y * neww;
            if ((i >= 0) && (i < l)) {
                bmp[i] = point(tx, ty);
            }
        }
        create(bmp, neww);
        bmp = null;
    }

    // возвращает повернутую картинку,
    // при этом текущий битмап не меняется
    public static Image imgrotate(int angle) {
        sa = sin(angle);
        ca = cos(angle);
        int x = 0;
        int y = 0;
        int w = pwid;
        int h = phei;
        cx = x + (w >> 1);
        cy = y + (h >> 1);
        xyrotate(x, y);
        int x1 = tx;
        int y1 = ty;
        xyrotate(x + w - 1, y);
        int x2 = tx;
        int y2 = ty;
        xyrotate(x + w - 1, y + h - 1);
        int x3 = tx;
        int y3 = ty;
        xyrotate(x, y + h - 1);
        int x4 = tx;
        int y4 = ty;
        tx = min4(x1, x2, x3, x4);
        ty = min4(y1, y2, y3, y4);
        int neww = max4(x1, x2, x3, x4) - tx + 1;
        int newh = max4(y1, y2, y3, y4) - ty + 1;
        int l = neww * newh;
        int[] bmp2 = null;
        bmp2 = new int[l];
        int dx = (neww - w) >> 1;
        int dy = (newh - h) >> 1;
        for(x = 0; x < neww; x++)
        for(y = 0; y < newh; y++) {
            xyrotate(x - dx, y - dy);
            int i = x + y * neww;
            if ((i >= 0) && (i < l)) {
                bmp2[i] = point(tx, ty);
            }
        }
        return Image.createRGBImage(bmp2, neww, newh, true);
    }

    // изменить размер картинки
    // битмап растягивается без сглаживания
    public static void resize(int neww, int newh) {
        int l = neww * newh;
        int[] bmp = new int[l];
        for (int y = 0; y < newh; y++)
        for (int x = 0; x < neww; x++) {
            bmp[y * neww + x] = point(x * pwid / neww, y * phei / newh);
        }
        pixels = null;
        pixels = new int[l];
        pwid = neww;
        phei = newh;
        create(bmp, pwid);
        bmp = null;
    }

    // обрубить битмап, оставив только заданную область
    // (можно и увеличить канву)
    public static void cut(int x, int y, int w, int h) {
        int l = w * h;
        int[] bmp = new int[l];
        for (int iy = 0; iy < h; iy++)
        for (int ix = 0; ix < w; ix++) {
            bmp[iy * w + ix] = point(ix + x, iy + y);
        }
        pixels = null;
        pixels = new int[l];
        pwid = w;
        phei = h;
        create(bmp, pwid);
        bmp = null;
    }

    // нарисовать массив пикселей на текущем битмапе по заданным координатам
    // если alphaDraw = 0, то рисуется если прозрачность пиксела rgb[] выше пороговой
    // если alphaDraw = 1, то рисуется с учетом альфа-канала - смешивается
    // если alphaDraw > 1, то пикселы замещаются новыми
    private static void drawrgb(int[] rgb, int x, int y, int w, int alphadraw) {
        int h = rgb.length / w;
        if((alphadraw == _mix)) {
            for(int iy = 0; iy < h; iy++)
            for(int ix = 0; ix < w; ix++) {
                plot(x + ix, y + iy, rgb[ix + w * iy]);
            }
        } else {
            for(int iy = 0; iy < h; iy++)
            for(int ix = 0; ix < w; ix++) {
                setpixel(x + ix, y + iy, rgb[ix + w * iy]);
            }
        }
    }

    // нарисовать изображение на текущем битмапе по заданным координатам
    // если alphaDraw = 0, то рисуется если прозрачность пиксела img выше пороговой
    // если alphaDraw = 1, то рисуется с учетом альфа-канала - смешивается
    // если alphaDraw > 1, то пикселы замещаются новыми
    public static void drawimage(Image img, int x, int y, int alphadraw) {
        int w = img.getWidth();
        int h = img.getHeight();
        int[] rgb = new int[w * h];
        if ((w | h) != 0) {
            img.getRGB(rgb, 0, w, 0, 0, w, h);
        }
        if((alphadraw == _mix)) {
            for(int iy = 0; iy < h; iy++)
            for(int ix = 0; ix < w; ix++) {
                plot(x + ix, y + iy, rgb[ix + w * iy]);
            }
        } else {
            for(int iy = 0; iy < h; iy++)
            for(int ix = 0; ix < w; ix++) {
                setpixel(x + ix, y + iy, rgb[ix + w * iy]);
            }
        }
        rgb = null;
    }

    // изменить размер канвы
    // если a45 = 0, то выравнивание по центру
    // если a45 = 1, то выравнивание по правому краю
    // если a45 = 2, то выравнивание по правому верхнему углу
    // если a45 = 3, то выравнивание по верхнему краю
    // если a45 = 4, то выравнивание по левому верхнему углу
    // и т.д.
    // (a45 - 1) * 45 = угол, по которому ведется выравнивание
    public static void canvassize(int w, int h, int a45) {
        a45 %= 8;
        if (a45 < 0) {
            a45 = 8 + a45;
        }
        int x = (pwid - w) / 2;
        int y = (phei - h) / 2;
        if((a45 == 1)||(a45 == 2)||(a45 == 8)) {
            x = pwid - w;
        }
        if((a45 == 4)||(a45 == 5)||(a45 == 6)) {
            x = 0;
        }
        if((a45 == 6)||(a45 == 7)||(a45 == 8)) {
            y = phei - h;
        }
        if((a45 == 2)||(a45 == 3)||(a45 == 4)) {
            y = 0;
        }
        cut(x, y, w, h);
    }

    // сдвиг битмапа на dx точек по горизонтали и dy - по вертикали
    public static void scroll(int dx, int dy) {
        int l = pwid * phei;
        int[] bmp = null;
        bmp = new int[l];
        for (int y = 0; y < phei; y++)
        for (int x = 0; x < pwid; x++) {
            int xx = x + dx;
            int yy = y + dy;
            if (inrect(xx, yy)==1) {
                bmp[yy * pwid + xx] = pixels[pwid * y + x];
            }
        }
        create(bmp, pwid);
        bmp = null;
    }

    // перекрашиваем rgb битмапа в цвет c, оставляя только прежний альфа-канал
    public static void mask(int c) {
        int l = pwid * phei;
        c &= 0x00ffffff;
        for(int i = 0; i < l; i++) {
            pixels[i] = (pixels[i] & 0xff000000) | c;
        }
    }

    // добавление тени
    // тень цвета c создается с учетом альфа канала
    // (медленно)
    public static void shadow(int dx, int dy, int c) {
        int l = pwid * phei;
        int[] bmp = null;
        bmp = new int[l];
        for(int i = 0; i < l; i++) {
            bmp[i] = pixels[i];
        }
        scroll(dx, dy);
        mask(c);
        drawrgb(bmp, 0, 0, pwid, 1);
        bmp = null;
    }

    // наклон картинки на 1/8 высоты
    // для создания эффекта курсива в шрифтах
    public static void italic() {
        int dw = phei >> 4;
        int ih = phei / dw;
        int dh = phei / ih;
        int neww = pwid + (phei / dh);
        int[] bmp = null;
        bmp = new int[neww * phei];
        for(int y = 0; y < phei; y++)
        for(int x = 0; x < neww; x++){
            bmp[x + neww * y] = point(x - (phei - y) / dh, y);
        }
        create(bmp, neww);
        bmp = null;
    }

    // наложение копии битмапа, сдвинутой на пиксел вправо
    // (создает эффет полужирного шрифта)
    // bold(0) - если шрифт непрозрачный
    public static void bold() {
        drawimage(getimage(), -8, 0, _mix);
    }

    public static String copyright() {
        return "© barsunduk © 11/2011";
    }

    // заменить все цвета на 0x00, но с альфа каналом,
    // равным среднему арифметическому от каналов RGB
    // для создания монохромного шрифта, но со сглаживанием по альфа каналу
    // из серого шрифта на белом фоне делаем черный полупрозрачный
    public static void mono() {
	int l = pwid * phei;
        for (int i = 0; i < l; i++) {
            int col = pixels[i];
            int a = (col >> 24) & 0xff;
            // если пиксел непрозрачный,
            // то делаем его черным,
            // но полупрозрачным
            int r = (col >> 16) & 0xff;
            int g = (col >> 8) & 0xff;
            int b = col & 0xff;
//            int a2 = (a == 255) ? 255 - ((r + g + b) / 3) : 0x0;
            int a2 = (a != 0) ? 255 - ((r + g + b) / 3) : 0x0;
            a2 &= a;
            pixels[i] = ((a2 & 0xff) << 24);
        }
    }

}